<?php
namespace Teknisa\PED\Modules\Pedidos\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

    class ped02600ParametrosPedidosFactory {
    
        protected $connection;

        public function __construct(EntityManager $entityManager) {
            $this->connection       = $entityManager->getConnection();
            $this->entityManager    = $entityManager;
        }
    
        public function selectParExp($nrorg,$cdfilial){
            try {
                $sql = "SELECT 
                            IDCTRLVENEXP 
                            FROM PAREXPEDICAO
                                WHERE NRORG = :NRORG 
                                AND CDFILIAL = :CDFILIAL";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDFILIAL'=>$cdfilial
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function salvaParExp($nrorg, $cdfilial, $IDCTRLVENEXP){
            try {
                $sql = "UPDATE PAREXPEDICAO
                            SET IDCTRLVENEXP = :IDCTRLVENEXP
                            WHERE NRORG = :NRORG AND
                                CDFILIAL = :CDFILIAL";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDFILIAL'=>$cdfilial,
                    'IDCTRLVENEXP'=>$IDCTRLVENEXP
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function selectParGer($nrorg){
            try {
                $sql = "SELECT 
                            IDUTCTREMPEN
                                FROM PARAMGERAL
                                WHERE NRORG = :NRORG";
            
                $params = array(
                    'NRORG'=>$nrorg
                );
                
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function salvaParGer($nrorg, $IDUTCTREMPEN){
            try {
                $sql = "UPDATE PARAMGERAL
                            SET IDUTCTREMPEN = :IDUTCTREMPEN
                            WHERE NRORG = :NRORG";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'IDUTCTREMPEN'=>$IDUTCTREMPEN
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }

        public function selectAutGrupATPR($nrorg, $cdfilial){
            try {
                $sql = "SELECT NRAUTGRUPOP, CDGRUPOPER
                            FROM AUTGRUPOP
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'ATPR'
                                AND CDFILIAL = :CDFILIAL";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDFILIAL'=>$cdfilial
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }

        public function uptdateAutoGrupATPR($nrorg, $CDGRUPOPER, $NRAUTGRUPOP, $CDFILIAL){
            try {
                $sql = "UPDATE AUTGRUPOP
                        SET CDGRUPOPER =:CDGRUPOPER
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'ATPR'
                                AND CDFILIAL = :CDFILIAL
                                AND NRAUTGRUPOP = :NRAUTGRUPOP";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDGRUPOPER'=>$CDGRUPOPER,
                    'NRAUTGRUPOP'=>$NRAUTGRUPOP, 
                    'CDFILIAL'=>$CDFILIAL
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function selectMaxNrAutGrupATPR($nrorg){
            try {
                $sql = "SELECT MAX(NVL(NRAUTGRUPOP, 0)) NRAUTGRUPOP
                                FROM AUTGRUPOP
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'ATPR'";
    
                $params = array(
                    'NRORG'=>$nrorg
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function insertAutGrupATPR($nrorg, $CDGRUPOPER,$NRAUTGRUPOP, $CDFILIAL){
            try {
                $sql = "INSERT INTO AUTGRUPOP
                            (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP, CDFILIAL, NRORG)
                                VALUES (:CDGRUPOPER, 'ATPR', :NRAUTGRUPOP, :CDFILIAL, :NRORG)";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDGRUPOPER'=>$CDGRUPOPER,
                    'NRAUTGRUPOP'=>$NRAUTGRUPOP, 
                    'CDFILIAL'=>$CDFILIAL
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function selectAutGrupTPED($nrorg, $cdfilial){
            try {
                $sql = "SELECT NRAUTGRUPOP, CDGRUPOPER
                            FROM AUTGRUPOP
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'TPED'
                                AND CDFILIAL = :CDFILIAL";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDFILIAL'=>$cdfilial
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }

        public function uptdateAutoGrupTPED($nrorg, $CDGRUPOPER, $NRAUTGRUPOP, $CDFILIAL){
            try {
                
                $sql = "UPDATE AUTGRUPOP
                        SET CDGRUPOPER =:CDGRUPOPER
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'TPED'
                                AND CDFILIAL = :CDFILIAL
                                AND NRAUTGRUPOP = :NRAUTGRUPOP";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDGRUPOPER'=>$CDGRUPOPER,
                    'NRAUTGRUPOP'=>$NRAUTGRUPOP, 
                    'CDFILIAL'=>$CDFILIAL
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        public function deleteAutoGrupTPED($CDFILIAL){
            
            try {
                
                $sql = "DELETE FROM AUTGRUPOP
                         WHERE IDAUTGRUPOP = 'TPED'
                               AND CDFILIAL    = :CDFILIAL";
    
                $params = array(
                    'CDFILIAL'=>$CDFILIAL
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function selectMaxNrAutGrupTPED($nrorg){
            try {
                $sql = "SELECT MAX(NVL(NRAUTGRUPOP, 0)) NRAUTGRUPOP
                                FROM AUTGRUPOP
                                WHERE NRORG = :NRORG
                                AND IDAUTGRUPOP = 'TPED'";
    
                $params = array(
                    'NRORG'=>$nrorg
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
                return $std->fetchAll();
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function insertAutGrupTPED($nrorg, $CDGRUPOPER, $NRAUTGRUPOP, $CDFILIAL){
            try {
                $sql = "INSERT INTO AUTGRUPOP
                            (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP, CDFILIAL, NRORG)
                                VALUES (:CDGRUPOPER, 'TPED', :NRAUTGRUPOP, :CDFILIAL, :NRORG)";
    
                $params = array(
                    'NRORG'=>$nrorg,
                    'CDGRUPOPER'=>$CDGRUPOPER,
                    'NRAUTGRUPOP'=>$NRAUTGRUPOP, 
                    'CDFILIAL'=>$CDFILIAL
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                
            }catch (\Exception $e) {
                throw $e;
            }
        }
        
    }

?>