CREATE OR REPLACE PROCEDURE APURAC_RETROATIVO_GD(
   P_CDFILIFATU   IN CTRLAPURFAT.CDFILIAL%TYPE,
   P_NRAPURACFAT  IN NOTAFISCAL.NRAPURACFAT%TYPE,
   P_DTINIAPURAC  IN CTRLAPURFAT.DTINIAPURAC%TYPE,
   P_DTFIMAPURAC  IN CTRLAPURFAT.DTFIMAPURAC%TYPE,
   P_CDFILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_DTPROC       IN DATE,
   P_PRXAPURACFAT OUT CTRLAPURFAT.NRAPURFATRETRO%TYPE) AS

   DOVRSERV      NUMBER;
   DOVRSERVATUAL NUMBER;
   V_CDTIPOOPER        VARCHAR2(02) DEFAULT '01';
   V_NRLANCTONF        NOTAFISCAL.NRLANCTONF%TYPE;
   V_CDEMPRESA         VARCHAR2(02);
   V_IDFATUPLAN        VARCHAR2(01);
   STIDTIPNFEMP        VARCHAR2(01);
   V_CDTURNO           EFECLIFATTUR.CDTURNO%TYPE;
   V_CDINSCMUNI        FILIAL.CDINSCMUNI%TYPE;
   V_CDINSCESTA        FILIAL.CDINSCESTA%TYPE;
   V_CDSERIE           FILIAL.CDSERIE%TYPE;
   V_CDPRODUTO         PRODUTO.CDPRODUTO%TYPE;
   V_CDSERVFILI        SERVICO.CDSERVFILI%TYPE;
   V_NMSERVICO         ITEMPRODUTO.DSPRODEMIS%TYPE;
   V_IDTPIJURCLIE      CLIENTE.IDTPIJURCLIE%TYPE;
   V_NRINSJURCLIE      CLIENTE.NRINSJURCLIE%TYPE;
   V_IDSERIEAUTO       VARCHAR2(01);
   V_CDCLIENTE         CLIENTE.CDCLIENTE%TYPE;
   P_NEWAPURACFAT      VARCHAR2(20);
   V_VRSERVICO         NUMBER;
   V_QTEFETSERV        NUMBER;
   V_STIDTIPNFEMP      VARCHAR2(01);
   V_IDUTPROPEMIS      VARCHAR2(01);
   V_CDTIPOFATUR       PARAMFILIAL.CDTIPOFATUR%TYPE;
   V_CDPRODPRESTSERV   VARCHAR2(10);
   V_TTITENSNF         NUMBER;
   V_PRXLANCESTQ       VARCHAR2(10);
   V_CDARVPROD         PRODUTO.CDARVPROD%TYPE;
   V_NMPRODUTO         PRODUTO.NMPRODUTO%TYPE;
   V_QTDEMINIEFET      NUMBER;
   V_IDMINIEFET        VARCHAR2(01);

   /*CONTROLE DE GERACAO DA NOTA*/
   V_CTRL_PRODUTO BOOLEAN;
   V_CTRL_CORPO BOOLEAN;
   V_QTAPUR NUMBER;
   V_EXISTE NUMBER;
   V_CDCLIENTE_OLD VARCHAR2(21);

BEGIN
   V_QTAPUR := 0;
   V_CTRL_PRODUTO := FALSE;
   V_CTRL_CORPO := true; /*FALSE;*/

   SELECT MAX(CDTIPOFATUR), MAX(SUBSTR(DSPARAMFATFI,01,1))
   INTO V_CDTIPOFATUR, V_IDMINIEFET
   FROM PARAMFILIAL
   WHERE CDFILIAL = P_CDFILIAL;

   IF (V_IDMINIEFET IS NULL) OR (V_IDMINIEFET = ' ') THEN
      V_IDMINIEFET := '1';
      -- POR DIA
   END IF;

   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD  = P_CDFILIFATU  AND
         NRAPURACGD    = P_NRAPURACFAT;

   FOR CURS_APURAC IN
     (SELECT APUR.CDFILIAL, APUR.CDCLIENTE, APUR.CDSERVFILI, APUR.DTEFETCLIE, SUM(APUR.QTCOMEFETCLI) AS QTCOMEFETCLI
      FROM(SELECT CDFILIAL, CDCLIENTE, CDSERVFILI, DTEFETCLIE, QTCOMEFETCLI
           FROM EFETCLIE
           WHERE CDFILIFATU = P_CDFILIFATU
             AND NRAPURACFAT = P_NRAPURACFAT
           UNION ALL
           SELECT CDFILIAL, CDCLIENTE, CDSERVFILI, DTFATURAM AS DTEFETCLIE, QTCOMEFATU AS QTCOMEFETCLI
           FROM EFECLIFAT
           WHERE CDFILIFATU = P_CDFILIFATU
             AND NRAPURACFAT = P_NRAPURACFAT) APUR
          INNER JOIN SERVICO S ON (S.CDFILIAL = APUR.CDFILIAL) AND (S.CDSERVFILI = APUR.CDSERVFILI) AND   
                                  ((S.IDFATUSERV   <> 'N') OR (S.IDFATUSERV IS NULL))
          GROUP BY APUR.CDFILIAL, APUR.CDCLIENTE, APUR.CDSERVFILI, APUR.DTEFETCLIE
          ORDER BY APUR.CDCLIENTE, APUR.CDSERVFILI, APUR.DTEFETCLIE) LOOP

      SELECT SUBSTR(MAX(IDFATUPLAN), 1, 1), SUBSTR(MAX(CDTURNO), 1, 4), SUBSTR(MAX(CDPRODUTO), 1, 10),
             SUBSTR(MAX(CDSERVFILI), 1, 5), SUBSTR(MAX(NMSERVICO), 1, 400)
      INTO V_IDFATUPLAN, V_CDTURNO, V_CDPRODUTO, V_CDSERVFILI, V_NMSERVICO
      FROM SUM_EFETIVOS
      WHERE DTFATURAM BETWEEN P_DTINIAPURAC AND P_DTFIMAPURAC AND
            CDFILIAL   = CURS_APURAC.CDFILIAL /*P_CDFILIFATU*/ AND
            CDCLIENTE  = CURS_APURAC.CDCLIENTE AND
            CDSERVFILI = CURS_APURAC.CDSERVFILI;

      DOVRSERV := 0;
      DOVRSERVATUAL := 0;
      DOVRSERV := UTIL_APURAC.CalcValrServ(CURS_APURAC.CDFILIAL, CURS_APURAC.CDCLIENTE,
                                           CURS_APURAC.CDSERVFILI, CURS_APURAC.DTEFETCLIE, V_CDTURNO);

      DOVRSERVATUAL := UTIL_APURAC.CalcValrServ(CURS_APURAC.CDFILIAL, CURS_APURAC.CDCLIENTE,
                                                CURS_APURAC.CDSERVFILI, SYSDATE, V_CDTURNO);

      /* CALCULA O MINIMO DE EFETIVOS */

      V_QTEFETSERV := CURS_APURAC.QTCOMEFETCLI;

      IF (DOVRSERVATUAL > DOVRSERV) AND (V_QTEFETSERV > 0) THEN
         V_VRSERVICO := DOVRSERVATUAL - DOVRSERV;

         SELECT COUNT(*)
           INTO V_EXISTE
         FROM TRAB_APURAC_GD
         WHERE CDFILIALAPGD   = P_CDFILIFATU
           AND NRAPURACGD     = P_NRAPURACFAT
           AND CDCLIENTEAPGD  = CURS_APURAC.CDCLIENTE
           AND CDSERVFILIAPGD = CURS_APURAC.CDSERVFILI
           AND VRPRECUNITAPGD = V_VRSERVICO;

         IF (V_EXISTE = 0) THEN
            INSERT INTO TRAB_APURAC_GD(
               CDFILIALAPGD, CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
               NREFETIVOSAPGD, NRAPURACGD, DTAPURACFATGD)
            VALUES(P_CDFILIFATU, CURS_APURAC.CDCLIENTE, CURS_APURAC.CDSERVFILI, V_VRSERVICO,
               V_QTEFETSERV, P_NRAPURACFAT, P_DTPROC);
         ELSE
            UPDATE TRAB_APURAC_GD
            SET NREFETIVOSAPGD = NREFETIVOSAPGD + V_QTEFETSERV
         WHERE CDFILIALAPGD   = P_CDFILIFATU
           AND NRAPURACGD     = P_NRAPURACFAT
           AND CDCLIENTEAPGD  = CURS_APURAC.CDCLIENTE
           AND CDSERVFILIAPGD = CURS_APURAC.CDSERVFILI
           AND VRPRECUNITAPGD = V_VRSERVICO;

         END IF;
      END IF;
   END LOOP;

   V_CDCLIENTE_OLD := '';
   FOR CURS_TRAB IN(
      SELECT CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
             NRAPURACGD, DTAPURACFATGD, SUM(NREFETIVOSAPGD) AS NREFETIVOSAPGD
      FROM TRAB_APURAC_GD
      WHERE CDFILIALAPGD = P_CDFILIFATU
        AND NRAPURACGD = P_NRAPURACFAT
      GROUP BY CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
               NRAPURACGD, DTAPURACFATGD
      ORDER BY CDCLIENTEAPGD
   )LOOP

      SELECT SUBSTR(MAX(IDFATUPLAN), 1, 1), SUBSTR(MAX(CDTURNO), 1, 4), SUBSTR(MAX(CDPRODUTO), 1, 10),
             SUBSTR(MAX(CDSERVFILI), 1, 5), SUBSTR(MAX(NMSERVICO), 1, 400)
      INTO V_IDFATUPLAN, V_CDTURNO, V_CDPRODUTO, V_CDSERVFILI, V_NMSERVICO
      FROM SUM_EFETIVOS
      WHERE DTFATURAM BETWEEN P_DTINIAPURAC AND P_DTFIMAPURAC AND
            CDFILIAL   = P_CDFILIAL AND
            CDCLIENTE  = CURS_TRAB.CDCLIENTEAPGD AND
            CDSERVFILI = CURS_TRAB.CDSERVFILIAPGD;

      IF V_CDCLIENTE_OLD <> CURS_TRAB.CDCLIENTEAPGD THEN
         V_CTRL_CORPO := TRUE;
      END IF;

      V_CTRL_PRODUTO := TRUE;
      V_QTAPUR := V_QTAPUR + 1;
      V_CDCLIENTE := CURS_TRAB.CDCLIENTEAPGD;
      V_VRSERVICO := CURS_TRAB.VRPRECUNITAPGD;

      /* BUSCA AS INFORMAOES PARA CADASTRAMENTO DA NOTA FISCAL */
      SELECT MAX(CDEMPRESA), MAX(CDINSCMUNI), MAX(CDINSCESTA), MAX(CDSERIE)
      INTO V_CDEMPRESA, V_CDINSCMUNI, V_CDINSCESTA, V_CDSERIE
      FROM FILIAL
      WHERE CDFILIAL = P_CDFILIAL;

      SELECT NVL(MAX(IDSERIEAUTO), 'N')
      INTO V_IDSERIEAUTO
      FROM TIPOOPERAC
      WHERE CDTIPOOPER   = V_CDTIPOOPER AND
            IDENTRSAIDOP = 'S';

      IF V_IDSERIEAUTO = 'S' THEN
         SELECT MAX(P.CDSERIE)
         INTO V_CDSERIE
         FROM PARAMSERIE P, FILIAL F, CLIENTE C
         WHERE F.CDFILIAL      = P_CDFILIAL AND
               NVL(F.CDFILIFISC, F.CDFILIAL) = P_CDFILIAL AND
               P.CDEMPRESA     = V_CDEMPRESA  AND
               P.CDINSCESTA    = V_CDINSCESTA AND
               P.CDINSCMUNI    = V_CDINSCMUNI AND
               P.CDTIPOOPER    = V_CDTIPOOPER AND
               C.CDCLIENTE     = V_CDCLIENTE  AND
               P.CDCONDICAOIVA = C.CDCONDIVACLI AND
               P.IDENTRSAIDOP  = 'S';
      END IF;

      /* BUSCA OS PARAMETROS DA PARAMGERAL E PARAMFILIAL */
      SELECT MAX(SUBSTR(DSPARAMFATGE,11,1)), NVL(MAX(IDUTPROPEMIS),'N'), MAX(SUBSTR(DSPARAMFATGE,1,10))
      INTO V_STIDTIPNFEMP, V_IDUTPROPEMIS, V_CDPRODPRESTSERV
      FROM PARAMGERAL;

      IF V_CDTIPOFATUR = '002' THEN
         STIDTIPNFEMP := '1';

         SELECT MAX(SUBSTR(DSPARAMFATGE,12,10))
         INTO V_CDPRODPRESTSERV
         FROM PARAMGERAL;
      ELSE
         IF (STIDTIPNFEMP IS NULL) OR (RTRIM(STIDTIPNFEMP) = '') THEN
            STIDTIPNFEMP := '2';
            -- REFEIO
         END IF;
      END IF;

      /* EFETUA O CADASTRAMENTO DO SERVICOS NA TABELA DE NOTA E ITENS */
      SELECT NVL(MAX(NRMAXITNF),10)
      INTO V_TTITENSNF
      FROM SERIENF
      WHERE CDEMPRESA  = V_CDEMPRESA  AND
            CDINSCESTA = V_CDINSCESTA AND
            CDINSCMUNI = V_CDINSCMUNI AND
            CDSERIE    = V_CDSERIE;

      SELECT MAX(IDTPIJURCLIE), MAX(NRINSJURCLIE)
      INTO V_IDTPIJURCLIE, V_NRINSJURCLIE
      FROM CLIENTE
      WHERE CDCLIENTE = V_CDCLIENTE;

      SELECT MAX(CDARVPROD), MAX(NMPRODUTO)
      INTO V_CDARVPROD, V_NMPRODUTO
      FROM PRODUTO
      WHERE CDPRODUTO = V_CDPRODPRESTSERV;

      IF V_CTRL_CORPO THEN
         NOVO_CODIGO('APURACFATUR' || /*P_CDFILIAL*/P_CDFILIFATU, P_NEWAPURACFAT);
         P_NEWAPURACFAT := SUBSTR(P_NEWAPURACFAT, 11, 10);

         GERA_NOTAFISCAL_CORPO(/*P_CDFILIAL*/P_CDFILIFATU,  P_CDFILIAL,      V_CDEMPRESA,
                               V_CDTIPOOPER,   V_CDSERIE,       V_CDCLIENTE,
                               TRUNC(SYSDATE),
                               'FAI',          V_NRLANCTONF,
                               V_PRXLANCESTQ,  'N',             NULL,
                               V_NRLANCTONF,   NULL,            NULL,
                               NULL,           NULL,            NULL,
                               NULL,           NULL,            NULL,
                               NULL,           NULL,            NULL,
                               NULL,           NULL,            NULL,
                               NULL,           SYSDATE,         NULL);

         /*Atualiza a CTRLAPURFAT com o numero da apuracao retroativa*/
         UPDATE CTRLAPURFAT
         SET CDFILIALRETRO   = P_CDFILIAL,
             NRAPURFATRETRO  = P_NEWAPURACFAT,
             DTAPURFATRETRO  = P_DTPROC
         WHERE
            CDFILIAL    = P_CDFILIFATU AND
            NRAPURACFAT = P_NRAPURACFAT;
         V_CTRL_CORPO := FALSE;
      END IF;
      IF V_CTRL_PRODUTO THEN
         IF STIDTIPNFEMP = '1' THEN
            GERA_NOTAFISCAL_PRODUTO(/*P_CDFILIAL*/P_CDFILIFATU, V_NRLANCTONF, V_CDPRODPRESTSERV,
                                    V_CDARVPROD, V_NMPRODUTO,
                                    CURS_TRAB.NREFETIVOSAPGD, V_VRSERVICO);
         ELSE
            /*Identificador de utilizao do cdigo e nome do produto como cdigo e descrio para emisso*/
            IF V_IDUTPROPEMIS = 'S' THEN
               SELECT MAX(CDARVPROD), MAX(NMPRODUTO)
               INTO V_CDARVPROD, V_NMPRODUTO
               FROM PRODUTO
               WHERE CDPRODUTO = V_CDPRODUTO;

               GERA_NOTAFISCAL_PRODUTO(/*P_CDFILIAL*/P_CDFILIFATU, V_NRLANCTONF, V_CDPRODUTO,
                                       V_CDARVPROD, V_NMPRODUTO,
                                       CURS_TRAB.NREFETIVOSAPGD, V_VRSERVICO);
            ELSE
               GERA_NOTAFISCAL_PRODUTO(/*P_CDFILIAL*/P_CDFILIFATU, V_NRLANCTONF, V_CDPRODUTO,
                                       V_CDSERVFILI, V_NMSERVICO,
                                       CURS_TRAB.NREFETIVOSAPGD, V_VRSERVICO);
            END IF;
         END IF;
         V_CTRL_PRODUTO := FALSE;
      END IF;

      V_CDCLIENTE_OLD := CURS_TRAB.CDCLIENTEAPGD;
   END LOOP;

   IF V_QTAPUR > 0 THEN
      GERA_NOTAFISCAL_FECHAMENTO(/*P_CDFILIAL*/P_CDFILIFATU, V_NRLANCTONF);

      UPDATE NOTAFISCAL
      SET CDFILIALRETRO = P_CDFILIAL,
          NRAPURFATNFRETR = P_NEWAPURACFAT
      WHERE CDFILIAL = /*P_CDFILIAL*/P_CDFILIFATU AND
            NRLANCTONF = V_NRLANCTONF;
      P_PRXAPURACFAT := P_NEWAPURACFAT;
   END IF;
   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD  = P_CDFILIFATU  AND
         NRAPURACGD    = P_NRAPURACFAT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('APURAC_RETROATIVO_GD','5.09.001'); END;
/
