<?php
namespace Teknisa\Model\Services\Repositories;


class FctApuracao extends \Doctrine\ORM\EntityRepository {


    public function invoiceValidateHasAlreadyBeenUsed($nrLanctoNF,$cdFilial) {
        $query =
            <<<SQL
                SELECT CONT.NRCONTRATOFCT,
                       TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS DTINICOMPET,
                        TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS DTFINCOMPET,
                         NRCONTRATOFCT || ' - ' ||TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') ||' até ' ||TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') AS MESSAGE
                  FROM FCT_APURACAO APU
                  JOIN FCT_RELACAPURACAOFATURA RELAPU
                    ON APU.NRAPURACAO = RELAPU.NRAPURACAO
                  JOIN FCT_FATURACONT FAT
                    ON RELAPU.NRFATURACONT = FAT.NRFATURACONT
                  JOIN FCT_RELACAGRUPCONTFAT RELFAT
                    ON FAT.NRFATURACONT = RELFAT.NRFATURACONT
                  JOIN FCT_CONTRATO CONT
                    ON RELFAT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                 WHERE APU.NRLANCTONF = :NRLANCTONF
                   AND APU.CDFILIAL   = :CDFILIAL
SQL;

        $params = array(
            "NRLANCTONF" => $nrLanctoNF,
            "CDFILIAL" => $cdFilial,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    
}